<script setup>
import { Page } from '@/app/core/pages/page';
import PageTitle from '@/app/components/blocks/PageTitle.vue';

import * as inputEnums from '@/app/enums/input';
import Input from '@/app/components/crud/particles/Input.vue';

import ProductsForm from '@/modules/exchange/components/excel/export/ProductsForm.vue';
import ProductBrandsForm from '@/modules/exchange/components/excel/export/ProductBrandsForm.vue';
import ProductVariationsForm from '@/modules/exchange/components/excel/export/ProductVariationsForm.vue';
import ReportsDSForm from '@/modules/exchange/components/excel/export/reports/ReportsDSForm.vue';
import ReportsSRForm from '@/modules/exchange/components/excel/export/reports/ReportsSRForm.vue';
import ShopsByCustomersForm from '@/modules/exchange/components/excel/export/shops/ByCustomersForm.vue';
import ShopsByRegionsForm from '@/modules/exchange/components/excel/export/shops/ByRegionsForm.vue';
import ShopsListForm from '@/modules/exchange/components/excel/export/shops/ListForm.vue';
import ShopSupplierForm from '@/modules/exchange/components/excel/export/ShopSupplierForm.vue';
</script>

<script>
export default {
    data() {
        return {
            page: new Page({
                context: this,
                title: this.__('EXCEL экспорт'),
            }),
            type: null,
        };
    },
    created() {
        this.page.init();
    },
    mounted() {
        $('select[name="exchange-excel-export-type"]').on('change', () => {
            let type = $('select[name="exchange-excel-export-type"]').val();
            this.type = type;

            setTimeout(() => {
                $('select[name="exchange-excel-export-type"]').val(type);
            }, 0);
        });
    },
};
</script>

<template>
    <PageTitle :text="page.title" />

    <div class="card card-primary">
        <div class="card-body">
            <Input
                :item="{
                    label: __('fields->type'),
                    name: 'exchange-excel-export-type',
                    type: inputEnums.types.select,
                    options: {
                        items: (context) => ({
                            'products': context.__('Продукты'),
                            'product_brands': context.__('Бренды'),
                            'product_variations': context.__('Вариации продуктов'),
                            'reports_ds': context.__('Отчёты (DS)'),
                            'reports_sr': context.__('Отчёты (SR)'),
                            'shops_list': context.__('Магазины (список)'),
                            'shops_by_customers': context.__('Магазины (по поставщикам)'),
                            'shops_by_regions': context.__('Магазины (по регионам)'),
                            'shop_suppliers': context.__('Поставщики'),
                        }),
                    },
                    wrapperSize: inputEnums.wrapperSizes.xl,
                }"
            />
        </div>
    </div>

    <ProductsForm v-if="type === 'products'" />
    <ProductBrandsForm v-else-if="type === 'product_brands'" />
    <ProductVariationsForm v-else-if="type === 'product_variations'" />
    <ReportsDSForm v-else-if="type === 'reports_ds'" />
    <ReportsSRForm v-else-if="type === 'reports_sr'" />
    <ShopsByCustomersForm v-else-if="type === 'shops_by_customers'" />
    <ShopsByRegionsForm v-else-if="type === 'shops_by_regions'" />
    <ShopsListForm v-else-if="type === 'shops_list'" />
    <ShopSupplierForm v-else-if="type === 'shop_suppliers'" />
</template>
